Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.Designer.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.Designer.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.Designer.cs	(revision 4368)
@@ -44,11 +44,4 @@
       this.exceptionLabel = new System.Windows.Forms.Label();
       this.projectLabel = new System.Windows.Forms.Label();
-      this.snapshotGroupBox = new System.Windows.Forms.GroupBox();
-      this.requestSnapshotButton = new System.Windows.Forms.Button();
-      this.openSnapshotButton = new System.Windows.Forms.Button();
-      this.snapshotTimeText = new System.Windows.Forms.TextBox();
-      this.snapshotStatusText = new System.Windows.Forms.TextBox();
-      this.snapshotTimeLabel = new System.Windows.Forms.Label();
-      this.snapshotStatusLabel = new System.Windows.Forms.Label();
       this.dateCalculatedText = new System.Windows.Forms.TextBox();
       this.dateCalculatedLabel = new System.Windows.Forms.Label();
@@ -59,11 +52,16 @@
       this.jobIdLabel = new System.Windows.Forms.Label();
       this.jobIdTextBox = new System.Windows.Forms.TextBox();
+      this.childJobsTabPage = new System.Windows.Forms.TabPage();
+      this.childJobItemListView = new HeuristicLab.Hive.Experiment.Views.JobItemListView();
       this.logTabPage = new System.Windows.Forms.TabPage();
       this.logView = new HeuristicLab.Core.Views.LogView();
-      this.snapshotGroupBox.SuspendLayout();
+      this.resultTabPage = new System.Windows.Forms.TabPage();
+      this.getLatestResultButton = new System.Windows.Forms.Button();
       this.jobStatusGroupBox.SuspendLayout();
       this.tabControl.SuspendLayout();
       this.detailsTabPage.SuspendLayout();
+      this.childJobsTabPage.SuspendLayout();
       this.logTabPage.SuspendLayout();
+      this.resultTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -245,80 +243,4 @@
       this.projectLabel.TabIndex = 20;
       this.projectLabel.Text = "Project:";
-      // 
-      // snapshotGroupBox
-      // 
-      this.snapshotGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.snapshotGroupBox.Controls.Add(this.requestSnapshotButton);
-      this.snapshotGroupBox.Controls.Add(this.openSnapshotButton);
-      this.snapshotGroupBox.Controls.Add(this.snapshotTimeText);
-      this.snapshotGroupBox.Controls.Add(this.snapshotStatusText);
-      this.snapshotGroupBox.Controls.Add(this.snapshotTimeLabel);
-      this.snapshotGroupBox.Controls.Add(this.snapshotStatusLabel);
-      this.snapshotGroupBox.Location = new System.Drawing.Point(6, 310);
-      this.snapshotGroupBox.Name = "snapshotGroupBox";
-      this.snapshotGroupBox.Size = new System.Drawing.Size(610, 100);
-      this.snapshotGroupBox.TabIndex = 21;
-      this.snapshotGroupBox.TabStop = false;
-      this.snapshotGroupBox.Text = "Latest Snapshot";
-      this.snapshotGroupBox.Visible = false;
-      // 
-      // requestSnapshotButton
-      // 
-      this.requestSnapshotButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.requestSnapshotButton.Location = new System.Drawing.Point(384, 67);
-      this.requestSnapshotButton.Name = "requestSnapshotButton";
-      this.requestSnapshotButton.Size = new System.Drawing.Size(107, 26);
-      this.requestSnapshotButton.TabIndex = 26;
-      this.requestSnapshotButton.Text = "Request Snapshot";
-      this.requestSnapshotButton.UseVisualStyleBackColor = true;
-      this.requestSnapshotButton.Click += new System.EventHandler(this.requestSnapshotButton_Click);
-      // 
-      // openSnapshotButton
-      // 
-      this.openSnapshotButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.openSnapshotButton.Location = new System.Drawing.Point(497, 67);
-      this.openSnapshotButton.Name = "openSnapshotButton";
-      this.openSnapshotButton.Size = new System.Drawing.Size(107, 26);
-      this.openSnapshotButton.TabIndex = 25;
-      this.openSnapshotButton.Text = "Open Snapshot";
-      this.openSnapshotButton.UseVisualStyleBackColor = true;
-      this.openSnapshotButton.Click += new System.EventHandler(this.openSnapshotButton_Click);
-      // 
-      // snapshotTimeText
-      // 
-      this.snapshotTimeText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.snapshotTimeText.Location = new System.Drawing.Point(45, 41);
-      this.snapshotTimeText.Name = "snapshotTimeText";
-      this.snapshotTimeText.Size = new System.Drawing.Size(559, 20);
-      this.snapshotTimeText.TabIndex = 24;
-      // 
-      // snapshotStatusText
-      // 
-      this.snapshotStatusText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.snapshotStatusText.Location = new System.Drawing.Point(45, 19);
-      this.snapshotStatusText.Name = "snapshotStatusText";
-      this.snapshotStatusText.Size = new System.Drawing.Size(559, 20);
-      this.snapshotStatusText.TabIndex = 23;
-      // 
-      // snapshotTimeLabel
-      // 
-      this.snapshotTimeLabel.AutoSize = true;
-      this.snapshotTimeLabel.Location = new System.Drawing.Point(6, 41);
-      this.snapshotTimeLabel.Name = "snapshotTimeLabel";
-      this.snapshotTimeLabel.Size = new System.Drawing.Size(33, 13);
-      this.snapshotTimeLabel.TabIndex = 22;
-      this.snapshotTimeLabel.Text = "Time:";
-      // 
-      // snapshotStatusLabel
-      // 
-      this.snapshotStatusLabel.AutoSize = true;
-      this.snapshotStatusLabel.Location = new System.Drawing.Point(6, 19);
-      this.snapshotStatusLabel.Name = "snapshotStatusLabel";
-      this.snapshotStatusLabel.Size = new System.Drawing.Size(40, 13);
-      this.snapshotStatusLabel.TabIndex = 21;
-      this.snapshotStatusLabel.Text = "Status:";
       // 
       // dateCalculatedText
@@ -379,5 +301,7 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.detailsTabPage);
+      this.tabControl.Controls.Add(this.childJobsTabPage);
       this.tabControl.Controls.Add(this.logTabPage);
+      this.tabControl.Controls.Add(this.resultTabPage);
       this.tabControl.Location = new System.Drawing.Point(3, 3);
       this.tabControl.Name = "tabControl";
@@ -393,5 +317,4 @@
       this.detailsTabPage.Controls.Add(this.jobStatusGroupBox);
       this.detailsTabPage.Controls.Add(this.userIdTextBox);
-      this.detailsTabPage.Controls.Add(this.snapshotGroupBox);
       this.detailsTabPage.Controls.Add(this.priorityTextBox);
       this.detailsTabPage.Controls.Add(this.projectLabel);
@@ -428,4 +351,27 @@
       this.jobIdTextBox.TabIndex = 26;
       // 
+      // childJobsTabPage
+      // 
+      this.childJobsTabPage.Controls.Add(this.childJobItemListView);
+      this.childJobsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.childJobsTabPage.Name = "childJobsTabPage";
+      this.childJobsTabPage.Size = new System.Drawing.Size(619, 492);
+      this.childJobsTabPage.TabIndex = 2;
+      this.childJobsTabPage.Text = "Child Jobs";
+      this.childJobsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // childJobItemListView
+      // 
+      this.childJobItemListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.childJobItemListView.Caption = "JobItemList View";
+      this.childJobItemListView.Content = null;
+      this.childJobItemListView.Location = new System.Drawing.Point(3, 3);
+      this.childJobItemListView.Name = "childJobItemListView";
+      this.childJobItemListView.ReadOnly = false;
+      this.childJobItemListView.Size = new System.Drawing.Size(613, 486);
+      this.childJobItemListView.TabIndex = 0;
+      // 
       // logTabPage
       // 
@@ -449,6 +395,25 @@
       this.logView.Name = "logView";
       this.logView.ReadOnly = false;
-      this.logView.Size = new System.Drawing.Size(536, 447);
+      this.logView.Size = new System.Drawing.Size(613, 486);
       this.logView.TabIndex = 0;
+      // 
+      // resultTabPage
+      // 
+      this.resultTabPage.Controls.Add(this.getLatestResultButton);
+      this.resultTabPage.Location = new System.Drawing.Point(4, 22);
+      this.resultTabPage.Name = "resultTabPage";
+      this.resultTabPage.Size = new System.Drawing.Size(619, 492);
+      this.resultTabPage.TabIndex = 3;
+      this.resultTabPage.Text = "Result";
+      this.resultTabPage.UseVisualStyleBackColor = true;
+      // 
+      // getLatestResultButton
+      // 
+      this.getLatestResultButton.Location = new System.Drawing.Point(4, 4);
+      this.getLatestResultButton.Name = "getLatestResultButton";
+      this.getLatestResultButton.Size = new System.Drawing.Size(112, 23);
+      this.getLatestResultButton.TabIndex = 0;
+      this.getLatestResultButton.Text = "Get latest result";
+      this.getLatestResultButton.UseVisualStyleBackColor = true;
       // 
       // JobItemView
@@ -459,6 +424,4 @@
       this.Name = "JobItemView";
       this.Size = new System.Drawing.Size(633, 524);
-      this.snapshotGroupBox.ResumeLayout(false);
-      this.snapshotGroupBox.PerformLayout();
       this.jobStatusGroupBox.ResumeLayout(false);
       this.jobStatusGroupBox.PerformLayout();
@@ -466,5 +429,7 @@
       this.detailsTabPage.ResumeLayout(false);
       this.detailsTabPage.PerformLayout();
+      this.childJobsTabPage.ResumeLayout(false);
       this.logTabPage.ResumeLayout(false);
+      this.resultTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -493,10 +458,4 @@
     private System.Windows.Forms.Label exceptionLabel;
     private System.Windows.Forms.Label projectLabel;
-    private System.Windows.Forms.GroupBox snapshotGroupBox;
-    private System.Windows.Forms.Button openSnapshotButton;
-    private System.Windows.Forms.TextBox snapshotTimeText;
-    private System.Windows.Forms.TextBox snapshotStatusText;
-    private System.Windows.Forms.Label snapshotTimeLabel;
-    private System.Windows.Forms.Label snapshotStatusLabel;
     private System.Windows.Forms.TextBox dateCalculatedText;
     private System.Windows.Forms.Label dateCalculatedLabel;
@@ -507,7 +466,10 @@
     private System.Windows.Forms.TabPage logTabPage;
     private Core.Views.LogView logView;
-    private System.Windows.Forms.Button requestSnapshotButton;
     private System.Windows.Forms.Label jobIdLabel;
     private System.Windows.Forms.TextBox jobIdTextBox;
+    private System.Windows.Forms.TabPage childJobsTabPage;
+    private JobItemListView childJobItemListView;
+    private System.Windows.Forms.TabPage resultTabPage;
+    private System.Windows.Forms.Button getLatestResultButton;
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/JobItemView.cs	(revision 4368)
@@ -12,4 +12,5 @@
 using HeuristicLab.Persistence.Default.Xml;
 using System.IO;
+using HeuristicLab.Hive.Experiment.Jobs;
 
 namespace HeuristicLab.Hive.Experiment.Views {
@@ -28,5 +29,4 @@
     public JobItemView() {
       InitializeComponent();
-      this.ReadOnly = true;
     }
 
@@ -34,11 +34,14 @@
       base.OnContentChanged();
       if (Content != null) {
-        logView.Content = Content.Log;
+        Content_JobChanged(this, EventArgs.Empty);
+        Content_ChildJobAdded(this, EventArgs.Empty);
+      }
+    }
+
+    void Content_JobChanged(object sender, EventArgs e) {
+      if (Content.Job != null) {
+        logView.Content = Content.Job.Log;
         Content_JobDtoChanged(this, EventArgs.Empty);
         Content_JobStateChanged(this, EventArgs.Empty);
-        if (Content.LatestSnapshot != null) {
-          snapshotStatusText.InvokeIfRequired(c => c.Text = Content.LatestSnapshot.StatusMessage.ToString());
-          snapshotTimeText.InvokeIfRequired(c => { c.Text = Content.LatestSnapshotTime.ToString(); });
-        }
       }
     }
@@ -46,15 +49,15 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.LatestSnapshotChanged += new EventHandler(Content_LatestSnapshotChanged);
+      Content.JobChanged += new EventHandler(Content_JobChanged);
       Content.JobDtoChanged += new EventHandler(Content_JobDtoChanged);
       Content.JobStateChanged += new EventHandler(Content_JobStateChanged);
-      Content.SnapshotRequestedStateChanged += new EventHandler(Content_SnapshotRequestedStateChanged);
+      Content.ChildJobAdded += new EventHandler(Content_ChildJobAdded);
     }
 
     protected override void DeregisterContentEvents() {
-      Content.LatestSnapshotChanged -= new EventHandler(Content_LatestSnapshotChanged);
+      Content.JobChanged -= new EventHandler(Content_JobChanged);
       Content.JobDtoChanged -= new EventHandler(Content_JobDtoChanged);
       Content.JobStateChanged -= new EventHandler(Content_JobStateChanged);
-      Content.SnapshotRequestedStateChanged -= new EventHandler(Content_SnapshotRequestedStateChanged);
+      Content.ChildJobAdded -= new EventHandler(Content_ChildJobAdded);
       base.DeregisterContentEvents();
     }
@@ -77,25 +80,18 @@
         Invoke(new EventHandler(Content_JobStateChanged), sender, e);
       } else {
-        this.stateTextBox.Text = Content.State.ToString();
-        this.percentageTextBox.Text = (Content.Percentage * 100).ToString() + "%";
-        this.percentageProgressBar.Value = Convert.ToInt32(Content.Percentage * percentageProgressBar.Maximum);
-        this.dateCalculatedText.Text = Content.DateCalculated.ToString();
-        this.dateFinishedTextBox.Text = Content.DateFinished.ToString();
-        this.exceptionTextBox.Text = Content.Exception;
+        this.stateTextBox.Text = Content.JobDto.State.ToString();
+        this.percentageTextBox.Text = (Content.JobDto.Percentage * 100).ToString() + "%";
+        this.percentageProgressBar.Value = Convert.ToInt32(Content.JobDto.Percentage * percentageProgressBar.Maximum);
+        this.dateCalculatedText.Text = Content.JobDto.DateCalculated.ToString();
+        this.dateFinishedTextBox.Text = Content.JobDto.DateFinished.ToString();
+        this.exceptionTextBox.Text = Content.JobDto.Exception;
       }
     }
 
-    void Content_LatestSnapshotChanged(object sender, EventArgs e) {
+    void Content_ChildJobAdded(object sender, EventArgs e) {
       if (InvokeRequired) {
-        Invoke(new EventHandler(Content_LatestSnapshotChanged), sender, e);
+        Invoke(new EventHandler(Content_ChildJobAdded), sender, e);
       } else {
-        if (Content.LatestSnapshot != null) {
-          snapshotStatusText.Text = Content.LatestSnapshot.StatusMessage.ToString();
-          snapshotTimeText.Text = Content.LatestSnapshotTime.ToString();
-        } else {
-          snapshotStatusText.Text = "";
-          snapshotTimeText.Text = "";
-        }
-        SetEnabledStateOfControls();
+        childJobItemListView.Content = new JobItemList(Content.ChildJobItems);
       }
     }
@@ -106,8 +102,4 @@
       } else {
         base.SetEnabledStateOfControls();
-        if (Content != null) {
-          openSnapshotButton.Enabled = Content.LatestSnapshot != null && Content.SnapshotRequestedState == SnapshotRequestedState.Idle;
-          requestSnapshotButton.Enabled = Content.SnapshotRequestedState == SnapshotRequestedState.Idle;
-        }
         this.jobIdTextBox.ReadOnly = this.ReadOnly;
         this.stateTextBox.ReadOnly = this.ReadOnly;
@@ -122,20 +114,5 @@
         this.exceptionTextBox.ReadOnly = this.ReadOnly;
         this.projectTextBox.ReadOnly = this.ReadOnly;
-        this.snapshotStatusText.ReadOnly = this.ReadOnly;
-        this.snapshotTimeText.ReadOnly = this.ReadOnly;
       }
-    }
-
-    private void openSnapshotButton_Click(object sender, EventArgs e) {
-      OptimizerJob job = XmlParser.Deserialize<OptimizerJob>(new MemoryStream(Content.LatestSnapshot.Obj.SerializedJobData));
-      MainFormManager.MainForm.ShowContent(job.Optimizer);
-    }
-
-    private void requestSnapshotButton_Click(object sender, EventArgs e) {
-      this.Content.RequestSnapshot();
-    }
-
-    private void Content_SnapshotRequestedStateChanged(object sender, EventArgs e) {
-      SetEnabledStateOfControls();
     }
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.Designer.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.Designer.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.Designer.cs	(revision 4368)
@@ -0,0 +1,96 @@
+﻿using HeuristicLab.MainForm.WindowsForms;
+namespace HeuristicLab.Hive.Experiment.Views {
+  partial class ProgressView : View {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.progressBar = new System.Windows.Forms.ProgressBar();
+      this.statusLabel = new System.Windows.Forms.Label();
+      this.cancelButton = new System.Windows.Forms.Button();
+      this.panel = new System.Windows.Forms.Panel();
+      this.panel.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // progressBar
+      // 
+      this.progressBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.progressBar.Location = new System.Drawing.Point(3, 3);
+      this.progressBar.Name = "progressBar";
+      this.progressBar.Size = new System.Drawing.Size(352, 23);
+      this.progressBar.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
+      this.progressBar.TabIndex = 0;
+      // 
+      // statusLabel
+      // 
+      this.statusLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.statusLabel.Location = new System.Drawing.Point(3, 33);
+      this.statusLabel.Name = "statusLabel";
+      this.statusLabel.Size = new System.Drawing.Size(352, 17);
+      this.statusLabel.TabIndex = 1;
+      // 
+      // cancelButton
+      // 
+      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.cancelButton.Location = new System.Drawing.Point(280, 53);
+      this.cancelButton.Name = "cancelButton";
+      this.cancelButton.Size = new System.Drawing.Size(75, 23);
+      this.cancelButton.TabIndex = 2;
+      this.cancelButton.Text = "Cancel";
+      this.cancelButton.UseVisualStyleBackColor = true;
+      this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
+      // 
+      // panel
+      // 
+      this.panel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.panel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
+      this.panel.Controls.Add(this.progressBar);
+      this.panel.Controls.Add(this.cancelButton);
+      this.panel.Controls.Add(this.statusLabel);
+      this.panel.Location = new System.Drawing.Point(0, 0);
+      this.panel.Name = "panel";
+      this.panel.Size = new System.Drawing.Size(360, 88);
+      this.panel.TabIndex = 3;
+      // 
+      // ProgressView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.panel);
+      this.Name = "ProgressView";
+      this.Size = new System.Drawing.Size(360, 88);
+      this.panel.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.ProgressBar progressBar;
+    private System.Windows.Forms.Label statusLabel;
+    private System.Windows.Forms.Button cancelButton;
+    private System.Windows.Forms.Panel panel;
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs	(revision 4368)
@@ -0,0 +1,130 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using HeuristicLab.MainForm.WindowsForms;
+using System.Windows.Forms;
+using System.Diagnostics;
+
+namespace HeuristicLab.Hive.Experiment.Views {
+  public partial class ProgressView : HeuristicLab.MainForm.WindowsForms.View {
+    private ContentView parentView = null;
+    private bool simulateProgress = false;
+
+    public bool CancelEnabled {
+      get {
+        return cancelButton.Visible;
+      }
+      set {
+        if (InvokeRequired) {
+          Invoke(new Action<bool>((ce) => { CancelEnabled = ce; }), value);
+        } else {
+          cancelButton.Visible = value;
+        }
+      }
+    }
+
+    private string status;
+    public string Status {
+      get { return status; }
+      set {
+        if (InvokeRequired) {
+          Invoke(new Action<string>((s) => { Status = s;}), value);
+        } else {
+          status = value;
+          statusLabel.Text = status;
+        }
+        
+      }
+    }
+
+    public ProgressView(ContentView parentView)
+      : this(parentView, "", false, true) {
+    }
+
+    public ProgressView(ContentView parentView, string initialStatus)
+      : this(parentView, initialStatus, false, true) {
+    }
+
+    public ProgressView(ContentView parentView, string initialStatus, bool simulateProgress)
+      : this(parentView, initialStatus, simulateProgress, true) {
+    }
+
+    /// <param name="parentView">This is the View which will be locked if lockParentView is true</param>
+    /// <param name="initialStatus">Status message</param>
+    /// <param name="simulateProgress">If true, the progress will be simulated by a timer which addes some progress every second</param>
+    /// <param name="lockParentView">if true parentView will be locked</param>
+    public ProgressView(ContentView parentView, string initialStatus, bool simulateProgress, bool lockParentView) {
+      InitializeComponent();
+      this.parentView = parentView;
+      this.CancelEnabled = false;
+      this.Status = initialStatus;
+      this.simulateProgress = simulateProgress;
+
+      if (simulateProgress) {
+        Timer progressSimulator = new Timer();
+        progressSimulator.Interval = 2000;
+        progressSimulator.Tick += new EventHandler(progressSimulator_Tick);
+        progressSimulator.Start();
+      }
+
+      this.Left = (parentView.ClientRectangle.Width / 2) - (this.Width / 2);
+      this.Top = (parentView.ClientRectangle.Height / 2) - (this.Height / 2);
+      this.Anchor = AnchorStyles.Left | AnchorStyles.Top;
+
+      if (lockParentView)
+        LockBackground();
+
+      parentView.Controls.Add(this);
+      this.BringToFront();
+    }
+
+    private void progressSimulator_Tick(object sender, EventArgs e) {
+      progressBar.Value = Math.Min(progressBar.Value + (progressBar.Maximum - progressBar.Value) / 10 + 1, progressBar.Maximum - 1);
+    }
+
+    private void LockBackground() {
+      this.parentView.Locked = true;
+      foreach (Control c in this.parentView.Controls) {
+        c.Enabled = false;
+      }
+      this.Enabled = true;
+      this.ReadOnly = false;
+    }
+
+    public void SetProgress(double progress) {
+      if (InvokeRequired) {
+        Invoke(new Action<double>(SetProgress), progress);
+      } else {
+        this.progressBar.Value = Math.Max(this.progressBar.Value, (int)(progress * progressBar.Maximum));
+      }
+    }
+
+    public void Finish() {
+      if (InvokeRequired) {
+        Invoke(new Action(Finish));
+      } else {
+        progressBar.Value = progressBar.Maximum;
+        parentView.Locked = false;
+        foreach (Control c in this.parentView.Controls) {
+          c.Enabled = true;
+        }
+        parentView.Controls.Remove(this);
+        this.Dispose();
+      }
+    }
+
+    private void cancelButton_Click(object sender, EventArgs e) {
+      Finish();
+    }
+
+    public event EventHandler Canceled;
+    protected virtual void OnCanceled() {
+      var handler = Canceled;
+      if (handler != null) Canceled(this, EventArgs.Empty);
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj	(revision 4368)
@@ -17,5 +17,5 @@
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
-    <PlatformTarget>AnyCPU</PlatformTarget>
+    <PlatformTarget>x64</PlatformTarget>
     <DebugSymbols>true</DebugSymbols>
     <DebugType>full</DebugType>
@@ -53,4 +53,29 @@
   <PropertyGroup>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Hive.Experiment-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Hive.Experiment-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
   </PropertyGroup>
   <ItemGroup>
@@ -93,7 +118,12 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="JobItem.cs" />
     <Compile Include="JobItemList.cs" />
-    <Compile Include="JobItem.cs" />
-    <Compile Include="OptimizerJob.cs" />
+    <Compile Include="Jobs\BachRunJob.cs" />
+    <Compile Include="Jobs\JobList.cs" />
+    <Compile Include="Jobs\ExperimentJob.cs" />
+    <Compile Include="HiveClient.cs" />
+    <Compile Include="HiveExperimentList.cs" />
+    <Compile Include="Jobs\OptimizerJob.cs" />
     <Compile Include="HeuristicLabHiveExperimentPlugin.cs" />
     <Compile Include="HiveExperiment.cs" />
